#include <qlistview.h>
#include <qstring.h>
#include <qstring.h>
#include "portitem.h"

PortItem::PortItem(QListView * parent, QString label1) : QListViewItem(parent, label1) {
}

PortItem::PortItem(PortItem * parent, QString label1) : QListViewItem(parent, label1) {
}

PortItem::~PortItem() {
}

int PortItem::compare (QListViewItem* i, int col, bool ascending) const {

  QString qs1, qs2, qs3, qs4, qs5, qs6;
  int index, num1, num2;

  qs1 = text(col);
  qs2 = i->text(col);
  for (index = qs1.length()-1; index > 0; index--) {
    if (!qs1.at(index).isDigit()) {
      break;
    }
  }
  qs3 = qs1.right(qs1.length() - index - 1);
  qs5 = qs1.left(index + 1);
  for (index = qs2.length()-1; index > 0; index--) {
    if (!qs2.at(index).isDigit()) {
      break;
    }
  }
  qs4 = qs2.right(qs2.length() - index - 1);
  qs6 = qs2.left(index + 1);
//  fprintf(stderr, "%s %s %s %s %s %s\n", qs1.latin1(), qs2.latin1(), qs3.latin1(), qs4.latin1(), qs5.latin1(), qs6.latin1());
  if (qs5 == qs6) {
    if ((num1 = qs3.toInt()) == (num2 = qs4.toInt())) {
      return(0);
    }
    if (ascending) {
      return((qs3.toInt() < qs4.toInt()) ? -1 : 1);
    } else {
      return((qs3.toInt() > qs4.toInt()) ? -1 : 1);
    }
  } else {
    if (qs5 < qs6) {
      return((ascending) ? -1 : 1);
    } else {
      return((ascending) ? 1 : -1);
    } 
  }
}
