#ifndef JACKCLIENT_H
#define JACKCLIENT_H

#include <qobject.h>
#include <qlist.h>
#include <qlistview.h>
#include "jackport.h"
#include "portitem.h"

/**
  *@author Matthias Nagorni
  */
    
class JackClient : public QObject  {
    
  Q_OBJECT
    
  public:
    QString clientName;
    QList<JackPort> portList;
    PortItem *listViewItem;
          
  public:
    JackClient();
    JackClient(QString p_clientName);
    ~JackClient();
};
                              
#endif
                              