#ifndef JACKPORT_H
#define JACKPORT_H

#include <qobject.h>
#include <qlist.h>
#include <qlistview.h>
#include "portitem.h"

/**
  *@author Matthias Nagorni
  */
    
class JackPort : public QObject  {
    
  Q_OBJECT
    
  public:
    QString portName;
    PortItem *listViewItem;
    QList<QObject> connectedPorts;
          
  public:
    JackPort();
    JackPort(QString p_portName);
    ~JackPort();
};
                              
#endif
                              